package utils_gorm

import (
	"database/sql"
	"fmt"
	"gorm.io/driver/mysql"
	"gorm.io/gorm"
)

func DB(driver string, dns string) (*gorm.DB, error, func()) {
	mysqlConn, err := sql.Open(driver, dns)
	gormDB, err := gorm.Open(
		mysql.New(mysql.Config{Conn: mysqlConn}),
	)
	return gormDB, err, func() {
		if mysqlConn != nil {
			if err := mysqlConn.Close(); err != nil {
				fmt.Println("关闭 DB 失败：", err)
			}
		}
	}
}
